'ESP8266 WiFi Module in Access Point Mode (AP)   [Wifi Remote Control]
'By Behnam Zakizadeh @ 94.06.17 [2015]
'www.avr64.com
'ver 2.0   @ 1395/03/28 [2016]


$regfile = "m8adef.dat"
$crystal = 11059200
$hwstack = 32
$swstack = 32
$framesize = 32
$baud = 115200

'optional
$projecttime = 0
$version 2 , 0 , 21
$prog &HC0 , &HBF , &HD1 , &H00                             ' generated. Take care that the chip supports all fuse bytes.


Enable Interrupts

Enable Urxc
On Urxc Recive_s

Dim I As Byte
Dim S As String * 250
Dim Pos As Byte
Dim Ssid As String * 32
Dim Password As String * 32
Dim Arr(500) As Byte
Dim Index As Word
Index = 1
Dim Relay_status As Bit
Dim Let_flag As Bit
Dim Timeout As Word


Declare Sub Gets()
Declare Sub Disp()


'Relay_1
Config Pinb.1 = Output
Relay1 Alias Portb.1

Deflcdchar 0 , 32 , 32 , 1 , 1 , 5 , 5 , 21 , 21            'ANTENNA

Config Lcdpin = Pin , Db4 = Portd.4 , Db5 = Portd.5 , Db6 = Portd.6 , _
 Db7 = Portd.7 , E = Portd.3 , Rs = Portd.2
Config Lcd = 16 * 2
Cursor Off Noblink
Cls

'============================ Main prog start here:

' >>>>>>>>>>>  SET YOUR ACCESS POINT SSID AND PASSWORD HERE <<<<<<<<<<<<

Ssid = "AVR64.com"                                          'AP Name
Password = "12345678"                                       'AP Password

'------------------------------


'dispaly info and firmvare version

Lcd "ESP8266 WiFi   " ; Chr(0)
Lowerline
Lcd "www.AVR64.com"
Wait 2

Cls : Lcd "Version:"
Lowerline : Lcd Version(2)
Wait 2

'-------------- get module startup data [not for all module]
Timeout = 0

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------


'start setup module
Cls : Lcd "Init..."
Waitms 500


'----------------- Test module
Timeout = 0
Index = 1
Print "AT"                                                  '[OPTIONAL] Test Module
Cls : Lcd "AT"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------

'================================
'Cls : Lcd "RESET Module..."

'Print "AT+RST"
'================================

'Wait 1



'----------------- Turn to Access Point mode
Timeout = 0
Index = 1
Print "AT+CWMODE=2"
Cls : Lcd "AP Mode..."
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------



'----------------- Setup Access Point
Timeout = 0
Index = 1
Print "AT+CWSAP={034}" ; Ssid ; "{034}" ; "," ; "{034}" ; Password ; "{034}" ; ",1,4"
'{034} -> is " (double quote character)
'1 -> is free wifi channel, 4 -> is Encryption Mode: WPA/WPA2
Cls : Lcd "Stp Access Point"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------


'----------------- Turn Multi Connection On
Timeout = 0
Index = 1
Print "AT+CIPMUX=1"
Cls : Lcd "Multi Connection"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------


'------------ Open a free Port to start a telnet server on it [start listeining]
Timeout = 0
Index = 1
Print "AT+CIPSERVER=1,1394"
Cls : Lcd "Open Port: 1394"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------


'------------ Display Module IP & MAC
Timeout = 0
Index = 1
Print "AT+CIFSR"
Cls : Lcd "Display IP & MAC"
Wait 1

While Index = 1
   Incr Timeout
   Waitms 1
   If Timeout > 2000 Then Exit While
Wend
Call Disp()
'-----------------------------------------------------------


Cls

Index = 1

Do
   Home : Lcd Index : Locate 1 , 16 : Lcd Chr(0)

   If Index > 10 Then
      Waitms 100
      Cls : Lcd Index : Locate 1 , 16 : Lcd Chr(0)
      Lowerline
      For I = 1 To Index
         If Arr(i) <> 10 And Arr(i) <> 13 Then
            Lcd Chr(arr(i))
            S = S + Chr(arr(i))
         End If
      Next I

      Pos = Instr(s , "on")
      If Pos > 0 Then
         Relay1 = 1 : Relay_status = 1
         Wait 1
         Print "AT+CIPSEND=0,15"
         Wait 1
         Print "RELAY TURN ON"

      End If

      Pos = Instr(s , "off")
      If Pos > 0 Then
         Relay1 = 0 : Relay_status = 0
         Wait 1
         Print "AT+CIPSEND=0,16"
         Wait 1
         Print "RELAY TURN OFF"
      End If

      Pos = Instr(s , "status")
      If Pos > 0 Then
         If Relay_status = 1 Then
            Print "AT+CIPSEND=0,13"
            Wait 1
            Print "Relay is On"
         Else
            Print "AT+CIPSEND=0,14"
            Wait 1
            Print "Relay is Off"
         End If
      End If

      'wait 1 sec to receive unused echo data
      Wait 1
      'move cursor of arr to 1 to clear unused received data
      Index = 1
      S = ""
      For I = 1 To 30
         Arr(i) = 32                                        'clr arr with space
      Next I


      Cls


   End If
Loop

End
'_______________________________________________________________________________

'convert and save received data from array Arr to string S
Sub Gets()
   S = ""
   Local I As Word
   For I = 1 To Index
      S = S + Chr(arr(i))
   Next I
End Sub
'_______________________________________________________________________________

'Display big string [stored in S] on LCD, page by page.
Sub Disp()
   Local Tmp As Word , Tmp2 As Word
   Cls : Lcd Index ; " Byte Rcvd" : Wait 1 : Cls

   If Index > 1 Then
      Lcd "Module Response:"
      For Tmp = 1 To Index
         Tmp2 = Tmp Mod 16
         If Tmp2 = 0 Then
            Tmp2 = 16
         End If
         Locate 2 , Tmp2

         If Arr(tmp) >= 32 And Arr(tmp) <= 126 Then         'ASCI Char
            Lcd Chr(arr(tmp))
         Else
            Lcd " "
         End If

         If Tmp2 = 16 Then
            Wait 2
            Lowerline : Lcd Spc(16)
         End If
      Next Tmp
      Wait 2
   Else
      Lcd "Module no reply" : Wait 1
   End If


End Sub
'_______________________________________________________________________________

Recive_s:
   Arr(index) = Udr
   If Index < 250 Then Incr Index                           'to prevent out bound of Array
Return

'End Of File